Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/dataanalysis.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs	(revision 7294)
@@ -1768,468 +2232,704 @@
 
     /*************************************************************************
-    Like MLPCreate0, but for ensembles.
+    DESCRIPTION:
+
+    This function creates MCPD (Markov Chains for Population Data) solver.
+
+    This  solver  can  be  used  to find transition matrix P for N-dimensional
+    prediction  problem  where transition from X[i] to X[i+1] is  modelled  as
+        X[i+1] = P*X[i]
+    where X[i] and X[i+1] are N-dimensional population vectors (components  of
+    each X are non-negative), and P is a N*N transition matrix (elements of  P
+    are non-negative, each column sums to 1.0).
+
+    Such models arise when when:
+    * there is some population of individuals
+    * individuals can have different states
+    * individuals can transit from one state to another
+    * population size is constant, i.e. there is no new individuals and no one
+      leaves population
+    * you want to model transitions of individuals from one state into another
+
+    USAGE:
+
+    Here we give very brief outline of the MCPD. We strongly recommend you  to
+    read examples in the ALGLIB Reference Manual and to read ALGLIB User Guide
+    on data analysis which is available at http://www.alglib.net/dataanalysis/
+
+    1. User initializes algorithm state with MCPDCreate() call
+
+    2. User  adds  one  or  more  tracks -  sequences of states which describe
+       evolution of a system being modelled from different starting conditions
+
+    3. User may add optional boundary, equality  and/or  linear constraints on
+       the coefficients of P by calling one of the following functions:
+       * MCPDSetEC() to set equality constraints
+       * MCPDSetBC() to set bound constraints
+       * MCPDSetLC() to set linear constraints
+
+    4. Optionally,  user  may  set  custom  weights  for prediction errors (by
+       default, algorithm assigns non-equal, automatically chosen weights  for
+       errors in the prediction of different components of X). It can be  done
+       with a call of MCPDSetPredictionWeights() function.
+
+    5. User calls MCPDSolve() function which takes algorithm  state and
+       pointer (delegate, etc.) to callback function which calculates F/G.
+
+    6. User calls MCPDResults() to get solution
+
+    INPUT PARAMETERS:
+        N       -   problem dimension, N>=1
+
+    OUTPUT PARAMETERS:
+        State   -   structure stores algorithm state
 
       -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreate0(int nin, int nout, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdcreate(int n, out mcpdstate s)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreate0(nin, nout, ensemblesize, ensemble.innerobj);
+        s = new mcpdstate();
+        mcpd.mcpdcreate(n, s.innerobj);
         return;
     }
 
     /*************************************************************************
-    Like MLPCreate1, but for ensembles.
+    DESCRIPTION:
+
+    This function is a specialized version of MCPDCreate()  function,  and  we
+    recommend  you  to read comments for this function for general information
+    about MCPD solver.
+
+    This  function  creates  MCPD (Markov Chains for Population  Data)  solver
+    for "Entry-state" model,  i.e. model  where transition from X[i] to X[i+1]
+    is modelled as
+        X[i+1] = P*X[i]
+    where
+        X[i] and X[i+1] are N-dimensional state vectors
+        P is a N*N transition matrix
+    and  one  selected component of X[] is called "entry" state and is treated
+    in a special way:
+        system state always transits from "entry" state to some another state
+        system state can not transit from any state into "entry" state
+    Such conditions basically mean that row of P which corresponds to  "entry"
+    state is zero.
+
+    Such models arise when:
+    * there is some population of individuals
+    * individuals can have different states
+    * individuals can transit from one state to another
+    * population size is NOT constant -  at every moment of time there is some
+      (unpredictable) amount of "new" individuals, which can transit into  one
+      of the states at the next turn, but still no one leaves population
+    * you want to model transitions of individuals from one state into another
+    * but you do NOT want to predict amount of "new"  individuals  because  it
+      does not depends on individuals already present (hence  system  can  not
+      transit INTO entry state - it can only transit FROM it).
+
+    This model is discussed  in  more  details  in  the ALGLIB User Guide (see
+    http://www.alglib.net/dataanalysis/ for more data).
+
+    INPUT PARAMETERS:
+        N       -   problem dimension, N>=2
+        EntryState- index of entry state, in 0..N-1
+
+    OUTPUT PARAMETERS:
+        State   -   structure stores algorithm state
 
       -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreate1(int nin, int nhid, int nout, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdcreateentry(int n, int entrystate, out mcpdstate s)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreate1(nin, nhid, nout, ensemblesize, ensemble.innerobj);
+        s = new mcpdstate();
+        mcpd.mcpdcreateentry(n, entrystate, s.innerobj);
         return;
     }
 
     /*************************************************************************
-    Like MLPCreate2, but for ensembles.
+    DESCRIPTION:
+
+    This function is a specialized version of MCPDCreate()  function,  and  we
+    recommend  you  to read comments for this function for general information
+    about MCPD solver.
+
+    This  function  creates  MCPD (Markov Chains for Population  Data)  solver
+    for "Exit-state" model,  i.e. model  where  transition from X[i] to X[i+1]
+    is modelled as
+        X[i+1] = P*X[i]
+    where
+        X[i] and X[i+1] are N-dimensional state vectors
+        P is a N*N transition matrix
+    and  one  selected component of X[] is called "exit"  state and is treated
+    in a special way:
+        system state can transit from any state into "exit" state
+        system state can not transit from "exit" state into any other state
+        transition operator discards "exit" state (makes it zero at each turn)
+    Such  conditions  basically  mean  that  column  of P which corresponds to
+    "exit" state is zero. Multiplication by such P may decrease sum of  vector
+    components.
+
+    Such models arise when:
+    * there is some population of individuals
+    * individuals can have different states
+    * individuals can transit from one state to another
+    * population size is NOT constant - individuals can move into "exit" state
+      and leave population at the next turn, but there are no new individuals
+    * amount of individuals which leave population can be predicted
+    * you want to model transitions of individuals from one state into another
+      (including transitions into the "exit" state)
+
+    This model is discussed  in  more  details  in  the ALGLIB User Guide (see
+    http://www.alglib.net/dataanalysis/ for more data).
+
+    INPUT PARAMETERS:
+        N       -   problem dimension, N>=2
+        ExitState-  index of exit state, in 0..N-1
+
+    OUTPUT PARAMETERS:
+        State   -   structure stores algorithm state
 
       -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreate2(int nin, int nhid1, int nhid2, int nout, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdcreateexit(int n, int exitstate, out mcpdstate s)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreate2(nin, nhid1, nhid2, nout, ensemblesize, ensemble.innerobj);
+        s = new mcpdstate();
+        mcpd.mcpdcreateexit(n, exitstate, s.innerobj);
         return;
     }
 
     /*************************************************************************
-    Like MLPCreateB0, but for ensembles.
+    DESCRIPTION:
+
+    This function is a specialized version of MCPDCreate()  function,  and  we
+    recommend  you  to read comments for this function for general information
+    about MCPD solver.
+
+    This  function  creates  MCPD (Markov Chains for Population  Data)  solver
+    for "Entry-Exit-states" model, i.e. model where  transition  from  X[i] to
+    X[i+1] is modelled as
+        X[i+1] = P*X[i]
+    where
+        X[i] and X[i+1] are N-dimensional state vectors
+        P is a N*N transition matrix
+    one selected component of X[] is called "entry" state and is treated in  a
+    special way:
+        system state always transits from "entry" state to some another state
+        system state can not transit from any state into "entry" state
+    and another one component of X[] is called "exit" state and is treated  in
+    a special way too:
+        system state can transit from any state into "exit" state
+        system state can not transit from "exit" state into any other state
+        transition operator discards "exit" state (makes it zero at each turn)
+    Such conditions basically mean that:
+        row of P which corresponds to "entry" state is zero
+        column of P which corresponds to "exit" state is zero
+    Multiplication by such P may decrease sum of vector components.
+
+    Such models arise when:
+    * there is some population of individuals
+    * individuals can have different states
+    * individuals can transit from one state to another
+    * population size is NOT constant
+    * at every moment of time there is some (unpredictable)  amount  of  "new"
+      individuals, which can transit into one of the states at the next turn
+    * some  individuals  can  move  (predictably)  into "exit" state and leave
+      population at the next turn
+    * you want to model transitions of individuals from one state into another,
+      including transitions from the "entry" state and into the "exit" state.
+    * but you do NOT want to predict amount of "new"  individuals  because  it
+      does not depends on individuals already present (hence  system  can  not
+      transit INTO entry state - it can only transit FROM it).
+
+    This model is discussed  in  more  details  in  the ALGLIB User Guide (see
+    http://www.alglib.net/dataanalysis/ for more data).
+
+    INPUT PARAMETERS:
+        N       -   problem dimension, N>=2
+        EntryState- index of entry state, in 0..N-1
+        ExitState-  index of exit state, in 0..N-1
+
+    OUTPUT PARAMETERS:
+        State   -   structure stores algorithm state
 
       -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreateb0(int nin, int nout, double b, double d, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdcreateentryexit(int n, int entrystate, int exitstate, out mcpdstate s)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreateb0(nin, nout, b, d, ensemblesize, ensemble.innerobj);
+        s = new mcpdstate();
+        mcpd.mcpdcreateentryexit(n, entrystate, exitstate, s.innerobj);
         return;
     }
 
     /*************************************************************************
-    Like MLPCreateB1, but for ensembles.
+    This  function  is  used to add a track - sequence of system states at the
+    different moments of its evolution.
+
+    You  may  add  one  or several tracks to the MCPD solver. In case you have
+    several tracks, they won't overwrite each other. For example,  if you pass
+    two tracks, A1-A2-A3 (system at t=A+1, t=A+2 and t=A+3) and B1-B2-B3, then
+    solver will try to model transitions from t=A+1 to t=A+2, t=A+2 to  t=A+3,
+    t=B+1 to t=B+2, t=B+2 to t=B+3. But it WONT mix these two tracks - i.e. it
+    wont try to model transition from t=A+3 to t=B+1.
+
+    INPUT PARAMETERS:
+        S       -   solver
+        XY      -   track, array[K,N]:
+                    * I-th row is a state at t=I
+                    * elements of XY must be non-negative (exception will be
+                      thrown on negative elements)
+        K       -   number of points in a track
+                    * if given, only leading K rows of XY are used
+                    * if not given, automatically determined from size of XY
+
+    NOTES:
+
+    1. Track may contain either proportional or population data:
+       * with proportional data all rows of XY must sum to 1.0, i.e. we have
+         proportions instead of absolute population values
+       * with population data rows of XY contain population counts and generally
+         do not sum to 1.0 (although they still must be non-negative)
 
       -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreateb1(int nin, int nhid, int nout, double b, double d, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdaddtrack(mcpdstate s, double[,] xy, int k)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreateb1(nin, nhid, nout, b, d, ensemblesize, ensemble.innerobj);
+
+        mcpd.mcpdaddtrack(s.innerobj, xy, k);
         return;
     }
-
-    /*************************************************************************
-    Like MLPCreateB2, but for ensembles.
-
-      -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpecreateb2(int nin, int nhid1, int nhid2, int nout, double b, double d, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdaddtrack(mcpdstate s, double[,] xy)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreateb2(nin, nhid1, nhid2, nout, b, d, ensemblesize, ensemble.innerobj);
+        int k;
+
+
+        k = ap.rows(xy);
+        mcpd.mcpdaddtrack(s.innerobj, xy, k);
+
         return;
     }
 
     /*************************************************************************
-    Like MLPCreateR0, but for ensembles.
+    This function is used to add equality constraints on the elements  of  the
+    transition matrix P.
+
+    MCPD solver has four types of constraints which can be placed on P:
+    * user-specified equality constraints (optional)
+    * user-specified bound constraints (optional)
+    * user-specified general linear constraints (optional)
+    * basic constraints (always present):
+      * non-negativity: P[i,j]>=0
+      * consistency: every column of P sums to 1.0
+
+    Final  constraints  which  are  passed  to  the  underlying  optimizer are
+    calculated  as  intersection  of all present constraints. For example, you
+    may specify boundary constraint on P[0,0] and equality one:
+        0.1<=P[0,0]<=0.9
+        P[0,0]=0.5
+    Such  combination  of  constraints  will  be  silently  reduced  to  their
+    intersection, which is P[0,0]=0.5.
+
+    This  function  can  be  used  to  place equality constraints on arbitrary
+    subset of elements of P. Set of constraints is specified by EC, which  may
+    contain either NAN's or finite numbers from [0,1]. NAN denotes absence  of
+    constraint, finite number denotes equality constraint on specific  element
+    of P.
+
+    You can also  use  MCPDAddEC()  function  which  allows  to  ADD  equality
+    constraint  for  one  element  of P without changing constraints for other
+    elements.
+
+    These functions (MCPDSetEC and MCPDAddEC) interact as follows:
+    * there is internal matrix of equality constraints which is stored in  the
+      MCPD solver
+    * MCPDSetEC() replaces this matrix by another one (SET)
+    * MCPDAddEC() modifies one element of this matrix and  leaves  other  ones
+      unchanged (ADD)
+    * thus  MCPDAddEC()  call  preserves  all  modifications  done by previous
+      calls,  while  MCPDSetEC()  completely discards all changes  done to the
+      equality constraints.
+
+    INPUT PARAMETERS:
+        S       -   solver
+        EC      -   equality constraints, array[N,N]. Elements of  EC  can  be
+                    either NAN's or finite  numbers from  [0,1].  NAN  denotes
+                    absence  of  constraints,  while  finite  value    denotes
+                    equality constraint on the corresponding element of P.
+
+    NOTES:
+
+    1. infinite values of EC will lead to exception being thrown. Values  less
+    than 0.0 or greater than 1.0 will lead to error code being returned  after
+    call to MCPDSolve().
 
       -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreater0(int nin, int nout, double a, double b, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdsetec(mcpdstate s, double[,] ec)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreater0(nin, nout, a, b, ensemblesize, ensemble.innerobj);
+
+        mcpd.mcpdsetec(s.innerobj, ec);
         return;
     }
 
     /*************************************************************************
-    Like MLPCreateR1, but for ensembles.
+    This function is used to add equality constraints on the elements  of  the
+    transition matrix P.
+
+    MCPD solver has four types of constraints which can be placed on P:
+    * user-specified equality constraints (optional)
+    * user-specified bound constraints (optional)
+    * user-specified general linear constraints (optional)
+    * basic constraints (always present):
+      * non-negativity: P[i,j]>=0
+      * consistency: every column of P sums to 1.0
+
+    Final  constraints  which  are  passed  to  the  underlying  optimizer are
+    calculated  as  intersection  of all present constraints. For example, you
+    may specify boundary constraint on P[0,0] and equality one:
+        0.1<=P[0,0]<=0.9
+        P[0,0]=0.5
+    Such  combination  of  constraints  will  be  silently  reduced  to  their
+    intersection, which is P[0,0]=0.5.
+
+    This function can be used to ADD equality constraint for one element of  P
+    without changing constraints for other elements.
+
+    You  can  also  use  MCPDSetEC()  function  which  allows  you  to specify
+    arbitrary set of equality constraints in one call.
+
+    These functions (MCPDSetEC and MCPDAddEC) interact as follows:
+    * there is internal matrix of equality constraints which is stored in the
+      MCPD solver
+    * MCPDSetEC() replaces this matrix by another one (SET)
+    * MCPDAddEC() modifies one element of this matrix and leaves  other  ones
+      unchanged (ADD)
+    * thus  MCPDAddEC()  call  preserves  all  modifications done by previous
+      calls,  while  MCPDSetEC()  completely discards all changes done to the
+      equality constraints.
+
+    INPUT PARAMETERS:
+        S       -   solver
+        I       -   row index of element being constrained
+        J       -   column index of element being constrained
+        C       -   value (constraint for P[I,J]).  Can  be  either  NAN  (no
+                    constraint) or finite value from [0,1].
+
+    NOTES:
+
+    1. infinite values of C  will lead to exception being thrown. Values  less
+    than 0.0 or greater than 1.0 will lead to error code being returned  after
+    call to MCPDSolve().
 
       -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreater1(int nin, int nhid, int nout, double a, double b, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdaddec(mcpdstate s, int i, int j, double c)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreater1(nin, nhid, nout, a, b, ensemblesize, ensemble.innerobj);
+
+        mcpd.mcpdaddec(s.innerobj, i, j, c);
         return;
     }
 
     /*************************************************************************
-    Like MLPCreateR2, but for ensembles.
+    This function is used to add bound constraints  on  the  elements  of  the
+    transition matrix P.
+
+    MCPD solver has four types of constraints which can be placed on P:
+    * user-specified equality constraints (optional)
+    * user-specified bound constraints (optional)
+    * user-specified general linear constraints (optional)
+    * basic constraints (always present):
+      * non-negativity: P[i,j]>=0
+      * consistency: every column of P sums to 1.0
+
+    Final  constraints  which  are  passed  to  the  underlying  optimizer are
+    calculated  as  intersection  of all present constraints. For example, you
+    may specify boundary constraint on P[0,0] and equality one:
+        0.1<=P[0,0]<=0.9
+        P[0,0]=0.5
+    Such  combination  of  constraints  will  be  silently  reduced  to  their
+    intersection, which is P[0,0]=0.5.
+
+    This  function  can  be  used  to  place bound   constraints  on arbitrary
+    subset  of  elements  of  P.  Set of constraints is specified by BndL/BndU
+    matrices, which may contain arbitrary combination  of  finite  numbers  or
+    infinities (like -INF<x<=0.5 or 0.1<=x<+INF).
+
+    You can also use MCPDAddBC() function which allows to ADD bound constraint
+    for one element of P without changing constraints for other elements.
+
+    These functions (MCPDSetBC and MCPDAddBC) interact as follows:
+    * there is internal matrix of bound constraints which is stored in the
+      MCPD solver
+    * MCPDSetBC() replaces this matrix by another one (SET)
+    * MCPDAddBC() modifies one element of this matrix and  leaves  other  ones
+      unchanged (ADD)
+    * thus  MCPDAddBC()  call  preserves  all  modifications  done by previous
+      calls,  while  MCPDSetBC()  completely discards all changes  done to the
+      equality constraints.
+
+    INPUT PARAMETERS:
+        S       -   solver
+        BndL    -   lower bounds constraints, array[N,N]. Elements of BndL can
+                    be finite numbers or -INF.
+        BndU    -   upper bounds constraints, array[N,N]. Elements of BndU can
+                    be finite numbers or +INF.
 
       -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreater2(int nin, int nhid1, int nhid2, int nout, double a, double b, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdsetbc(mcpdstate s, double[,] bndl, double[,] bndu)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreater2(nin, nhid1, nhid2, nout, a, b, ensemblesize, ensemble.innerobj);
+
+        mcpd.mcpdsetbc(s.innerobj, bndl, bndu);
         return;
     }
 
     /*************************************************************************
-    Like MLPCreateC0, but for ensembles.
+    This function is used to add bound constraints  on  the  elements  of  the
+    transition matrix P.
+
+    MCPD solver has four types of constraints which can be placed on P:
+    * user-specified equality constraints (optional)
+    * user-specified bound constraints (optional)
+    * user-specified general linear constraints (optional)
+    * basic constraints (always present):
+      * non-negativity: P[i,j]>=0
+      * consistency: every column of P sums to 1.0
+
+    Final  constraints  which  are  passed  to  the  underlying  optimizer are
+    calculated  as  intersection  of all present constraints. For example, you
+    may specify boundary constraint on P[0,0] and equality one:
+        0.1<=P[0,0]<=0.9
+        P[0,0]=0.5
+    Such  combination  of  constraints  will  be  silently  reduced  to  their
+    intersection, which is P[0,0]=0.5.
+
+    This  function  can  be  used to ADD bound constraint for one element of P
+    without changing constraints for other elements.
+
+    You  can  also  use  MCPDSetBC()  function  which  allows to  place  bound
+    constraints  on arbitrary subset of elements of P.   Set of constraints is
+    specified  by  BndL/BndU matrices, which may contain arbitrary combination
+    of finite numbers or infinities (like -INF<x<=0.5 or 0.1<=x<+INF).
+
+    These functions (MCPDSetBC and MCPDAddBC) interact as follows:
+    * there is internal matrix of bound constraints which is stored in the
+      MCPD solver
+    * MCPDSetBC() replaces this matrix by another one (SET)
+    * MCPDAddBC() modifies one element of this matrix and  leaves  other  ones
+      unchanged (ADD)
+    * thus  MCPDAddBC()  call  preserves  all  modifications  done by previous
+      calls,  while  MCPDSetBC()  completely discards all changes  done to the
+      equality constraints.
+
+    INPUT PARAMETERS:
+        S       -   solver
+        I       -   row index of element being constrained
+        J       -   column index of element being constrained
+        BndL    -   lower bound
+        BndU    -   upper bound
 
       -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreatec0(int nin, int nout, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdaddbc(mcpdstate s, int i, int j, double bndl, double bndu)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreatec0(nin, nout, ensemblesize, ensemble.innerobj);
+
+        mcpd.mcpdaddbc(s.innerobj, i, j, bndl, bndu);
         return;
     }
 
     /*************************************************************************
-    Like MLPCreateC1, but for ensembles.
+    This function is used to set linear equality/inequality constraints on the
+    elements of the transition matrix P.
+
+    This function can be used to set one or several general linear constraints
+    on the elements of P. Two types of constraints are supported:
+    * equality constraints
+    * inequality constraints (both less-or-equal and greater-or-equal)
+
+    Coefficients  of  constraints  are  specified  by  matrix  C (one  of  the
+    parameters).  One  row  of  C  corresponds  to  one  constraint.   Because
+    transition  matrix P has N*N elements,  we  need  N*N columns to store all
+    coefficients  (they  are  stored row by row), and one more column to store
+    right part - hence C has N*N+1 columns.  Constraint  kind is stored in the
+    CT array.
+
+    Thus, I-th linear constraint is
+        P[0,0]*C[I,0] + P[0,1]*C[I,1] + .. + P[0,N-1]*C[I,N-1] +
+            + P[1,0]*C[I,N] + P[1,1]*C[I,N+1] + ... +
+            + P[N-1,N-1]*C[I,N*N-1]  ?=?  C[I,N*N]
+    where ?=? can be either "=" (CT[i]=0), "<=" (CT[i]<0) or ">=" (CT[i]>0).
+
+    Your constraint may involve only some subset of P (less than N*N elements).
+    For example it can be something like
+        P[0,0] + P[0,1] = 0.5
+    In this case you still should pass matrix  with N*N+1 columns, but all its
+    elements (except for C[0,0], C[0,1] and C[0,N*N-1]) will be zero.
+
+    INPUT PARAMETERS:
+        S       -   solver
+        C       -   array[K,N*N+1] - coefficients of constraints
+                    (see above for complete description)
+        CT      -   array[K] - constraint types
+                    (see above for complete description)
+        K       -   number of equality/inequality constraints, K>=0:
+                    * if given, only leading K elements of C/CT are used
+                    * if not given, automatically determined from sizes of C/CT
 
       -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreatec1(int nin, int nhid, int nout, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdsetlc(mcpdstate s, double[,] c, int[] ct, int k)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreatec1(nin, nhid, nout, ensemblesize, ensemble.innerobj);
+
+        mcpd.mcpdsetlc(s.innerobj, c, ct, k);
         return;
     }
-
-    /*************************************************************************
-    Like MLPCreateC2, but for ensembles.
-
-      -- ALGLIB --
-         Copyright 18.02.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpecreatec2(int nin, int nhid1, int nhid2, int nout, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdsetlc(mcpdstate s, double[,] c, int[] ct)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreatec2(nin, nhid1, nhid2, nout, ensemblesize, ensemble.innerobj);
+        int k;
+        if( (ap.rows(c)!=ap.len(ct)))
+            throw new alglibexception("Error while calling 'mcpdsetlc': looks like one of arguments has wrong size");
+
+        k = ap.rows(c);
+        mcpd.mcpdsetlc(s.innerobj, c, ct, k);
+
         return;
     }
 
     /*************************************************************************
-    Creates ensemble from network. Only network geometry is copied.
+    This function allows to  tune  amount  of  Tikhonov  regularization  being
+    applied to your problem.
+
+    By default, regularizing term is equal to r*||P-prior_P||^2, where r is  a
+    small non-zero value,  P is transition matrix, prior_P is identity matrix,
+    ||X||^2 is a sum of squared elements of X.
+
+    This  function  allows  you to change coefficient r. You can  also  change
+    prior values with MCPDSetPrior() function.
+
+    INPUT PARAMETERS:
+        S       -   solver
+        V       -   regularization  coefficient, finite non-negative value. It
+                    is  not  recommended  to specify zero value unless you are
+                    pretty sure that you want it.
 
       -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpecreatefromnetwork(multilayerperceptron network, int ensemblesize, out mlpensemble ensemble)
+    public static void mcpdsettikhonovregularizer(mcpdstate s, double v)
     {
-        ensemble = new mlpensemble();
-        mlpe.mlpecreatefromnetwork(network.innerobj, ensemblesize, ensemble.innerobj);
+
+        mcpd.mcpdsettikhonovregularizer(s.innerobj, v);
         return;
     }
 
     /*************************************************************************
-    Randomization of MLP ensemble
+    This  function  allows to set prior values used for regularization of your
+    problem.
+
+    By default, regularizing term is equal to r*||P-prior_P||^2, where r is  a
+    small non-zero value,  P is transition matrix, prior_P is identity matrix,
+    ||X||^2 is a sum of squared elements of X.
+
+    This  function  allows  you to change prior values prior_P. You  can  also
+    change r with MCPDSetTikhonovRegularizer() function.
+
+    INPUT PARAMETERS:
+        S       -   solver
+        PP      -   array[N,N], matrix of prior values:
+                    1. elements must be real numbers from [0,1]
+                    2. columns must sum to 1.0.
+                    First property is checked (exception is thrown otherwise),
+                    while second one is not checked/enforced.
 
       -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlperandomize(mlpensemble ensemble)
+    public static void mcpdsetprior(mcpdstate s, double[,] pp)
     {
 
-        mlpe.mlperandomize(ensemble.innerobj);
+        mcpd.mcpdsetprior(s.innerobj, pp);
         return;
     }
 
     /*************************************************************************
-    Return ensemble properties (number of inputs and outputs).
+    This function is used to change prediction weights
+
+    MCPD solver scales prediction errors as follows
+        Error(P) = ||W*(y-P*x)||^2
+    where
+        x is a system state at time t
+        y is a system state at time t+1
+        P is a transition matrix
+        W is a diagonal scaling matrix
+
+    By default, weights are chosen in order  to  minimize  relative prediction
+    error instead of absolute one. For example, if one component of  state  is
+    about 0.5 in magnitude and another one is about 0.05, then algorithm  will
+    make corresponding weights equal to 2.0 and 20.0.
+
+    INPUT PARAMETERS:
+        S       -   solver
+        PW      -   array[N], weights:
+                    * must be non-negative values (exception will be thrown otherwise)
+                    * zero values will be replaced by automatically chosen values
 
       -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpeproperties(mlpensemble ensemble, out int nin, out int nout)
+    public static void mcpdsetpredictionweights(mcpdstate s, double[] pw)
     {
-        nin = 0;
-        nout = 0;
-        mlpe.mlpeproperties(ensemble.innerobj, ref nin, ref nout);
+
+        mcpd.mcpdsetpredictionweights(s.innerobj, pw);
         return;
     }
 
     /*************************************************************************
-    Return normalization type (whether ensemble is SOFTMAX-normalized or not).
+    This function is used to start solution of the MCPD problem.
+
+    After return from this function, you can use MCPDResults() to get solution
+    and completion code.
 
       -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static bool mlpeissoftmax(mlpensemble ensemble)
+    public static void mcpdsolve(mcpdstate s)
     {
 
-        bool result = mlpe.mlpeissoftmax(ensemble.innerobj);
-        return result;
-    }
-
-    /*************************************************************************
-    Procesing
-
-    INPUT PARAMETERS:
-        Ensemble-   neural networks ensemble
-        X       -   input vector,  array[0..NIn-1].
-        Y       -   (possibly) preallocated buffer; if size of Y is less than
-                    NOut, it will be reallocated. If it is large enough, it
-                    is NOT reallocated, so we can save some time on reallocation.
-
-
-    OUTPUT PARAMETERS:
-        Y       -   result. Regression estimate when solving regression  task,
-                    vector of posterior probabilities for classification task.
-
-      -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpeprocess(mlpensemble ensemble, double[] x, ref double[] y)
-    {
-
-        mlpe.mlpeprocess(ensemble.innerobj, x, ref y);
+        mcpd.mcpdsolve(s.innerobj);
         return;
     }
 
     /*************************************************************************
-    'interactive'  variant  of  MLPEProcess  for  languages  like Python which
-    support constructs like "Y = MLPEProcess(LM,X)" and interactive mode of the
-    interpreter
-
-    This function allocates new array on each call,  so  it  is  significantly
-    slower than its 'non-interactive' counterpart, but it is  more  convenient
-    when you call it from command line.
+    MCPD results
+
+    INPUT PARAMETERS:
+        State   -   algorithm state
+
+    OUTPUT PARAMETERS:
+        P       -   array[N,N], transition matrix
+        Rep     -   optimization report. You should check Rep.TerminationType
+                    in  order  to  distinguish  successful  termination  from
+                    unsuccessful one. Speaking short, positive values  denote
+                    success, negative ones are failures.
+                    More information about fields of this  structure  can  be
+                    found in the comments on MCPDReport datatype.
+
 
       -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpeprocessi(mlpensemble ensemble, double[] x, out double[] y)
+    public static void mcpdresults(mcpdstate s, out double[,] p, out mcpdreport rep)
     {
-        y = new double[0];
-        mlpe.mlpeprocessi(ensemble.innerobj, x, ref y);
-        return;
-    }
-
-    /*************************************************************************
-    Relative classification error on the test set
-
-    INPUT PARAMETERS:
-        Ensemble-   ensemble
-        XY      -   test set
-        NPoints -   test set size
-
-    RESULT:
-        percent of incorrectly classified cases.
-        Works both for classifier betwork and for regression networks which
-    are used as classifiers.
-
-      -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlperelclserror(mlpensemble ensemble, double[,] xy, int npoints)
-    {
-
-        double result = mlpe.mlperelclserror(ensemble.innerobj, xy, npoints);
-        return result;
-    }
-
-    /*************************************************************************
-    Average cross-entropy (in bits per element) on the test set
-
-    INPUT PARAMETERS:
-        Ensemble-   ensemble
-        XY      -   test set
-        NPoints -   test set size
-
-    RESULT:
-        CrossEntropy/(NPoints*LN(2)).
-        Zero if ensemble solves regression task.
-
-      -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlpeavgce(mlpensemble ensemble, double[,] xy, int npoints)
-    {
-
-        double result = mlpe.mlpeavgce(ensemble.innerobj, xy, npoints);
-        return result;
-    }
-
-    /*************************************************************************
-    RMS error on the test set
-
-    INPUT PARAMETERS:
-        Ensemble-   ensemble
-        XY      -   test set
-        NPoints -   test set size
-
-    RESULT:
-        root mean square error.
-        Its meaning for regression task is obvious. As for classification task
-    RMS error means error when estimating posterior probabilities.
-
-      -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlpermserror(mlpensemble ensemble, double[,] xy, int npoints)
-    {
-
-        double result = mlpe.mlpermserror(ensemble.innerobj, xy, npoints);
-        return result;
-    }
-
-    /*************************************************************************
-    Average error on the test set
-
-    INPUT PARAMETERS:
-        Ensemble-   ensemble
-        XY      -   test set
-        NPoints -   test set size
-
-    RESULT:
-        Its meaning for regression task is obvious. As for classification task
-    it means average error when estimating posterior probabilities.
-
-      -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlpeavgerror(mlpensemble ensemble, double[,] xy, int npoints)
-    {
-
-        double result = mlpe.mlpeavgerror(ensemble.innerobj, xy, npoints);
-        return result;
-    }
-
-    /*************************************************************************
-    Average relative error on the test set
-
-    INPUT PARAMETERS:
-        Ensemble-   ensemble
-        XY      -   test set
-        NPoints -   test set size
-
-    RESULT:
-        Its meaning for regression task is obvious. As for classification task
-    it means average relative error when estimating posterior probabilities.
-
-      -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlpeavgrelerror(mlpensemble ensemble, double[,] xy, int npoints)
-    {
-
-        double result = mlpe.mlpeavgrelerror(ensemble.innerobj, xy, npoints);
-        return result;
-    }
-
-    /*************************************************************************
-    Training neural networks ensemble using  bootstrap  aggregating (bagging).
-    Modified Levenberg-Marquardt algorithm is used as base training method.
-
-    INPUT PARAMETERS:
-        Ensemble    -   model with initialized geometry
-        XY          -   training set
-        NPoints     -   training set size
-        Decay       -   weight decay coefficient, >=0.001
-        Restarts    -   restarts, >0.
-
-    OUTPUT PARAMETERS:
-        Ensemble    -   trained model
-        Info        -   return code:
-                        * -2, if there is a point with class number
-                              outside of [0..NClasses-1].
-                        * -1, if incorrect parameters was passed
-                              (NPoints<0, Restarts<1).
-                        *  2, if task has been solved.
-        Rep         -   training report.
-        OOBErrors   -   out-of-bag generalization error estimate
-
-      -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpebagginglm(mlpensemble ensemble, double[,] xy, int npoints, double decay, int restarts, out int info, out mlpreport rep, out mlpcvreport ooberrors)
-    {
-        info = 0;
-        rep = new mlpreport();
-        ooberrors = new mlpcvreport();
-        mlpe.mlpebagginglm(ensemble.innerobj, xy, npoints, decay, restarts, ref info, rep.innerobj, ooberrors.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Training neural networks ensemble using  bootstrap  aggregating (bagging).
-    L-BFGS algorithm is used as base training method.
-
-    INPUT PARAMETERS:
-        Ensemble    -   model with initialized geometry
-        XY          -   training set
-        NPoints     -   training set size
-        Decay       -   weight decay coefficient, >=0.001
-        Restarts    -   restarts, >0.
-        WStep       -   stopping criterion, same as in MLPTrainLBFGS
-        MaxIts      -   stopping criterion, same as in MLPTrainLBFGS
-
-    OUTPUT PARAMETERS:
-        Ensemble    -   trained model
-        Info        -   return code:
-                        * -8, if both WStep=0 and MaxIts=0
-                        * -2, if there is a point with class number
-                              outside of [0..NClasses-1].
-                        * -1, if incorrect parameters was passed
-                              (NPoints<0, Restarts<1).
-                        *  2, if task has been solved.
-        Rep         -   training report.
-        OOBErrors   -   out-of-bag generalization error estimate
-
-      -- ALGLIB --
-         Copyright 17.02.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpebagginglbfgs(mlpensemble ensemble, double[,] xy, int npoints, double decay, int restarts, double wstep, int maxits, out int info, out mlpreport rep, out mlpcvreport ooberrors)
-    {
-        info = 0;
-        rep = new mlpreport();
-        ooberrors = new mlpcvreport();
-        mlpe.mlpebagginglbfgs(ensemble.innerobj, xy, npoints, decay, restarts, wstep, maxits, ref info, rep.innerobj, ooberrors.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Training neural networks ensemble using early stopping.
-
-    INPUT PARAMETERS:
-        Ensemble    -   model with initialized geometry
-        XY          -   training set
-        NPoints     -   training set size
-        Decay       -   weight decay coefficient, >=0.001
-        Restarts    -   restarts, >0.
-
-    OUTPUT PARAMETERS:
-        Ensemble    -   trained model
-        Info        -   return code:
-                        * -2, if there is a point with class number
-                              outside of [0..NClasses-1].
-                        * -1, if incorrect parameters was passed
-                              (NPoints<0, Restarts<1).
-                        *  6, if task has been solved.
-        Rep         -   training report.
-        OOBErrors   -   out-of-bag generalization error estimate
-
-      -- ALGLIB --
-         Copyright 10.03.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpetraines(mlpensemble ensemble, double[,] xy, int npoints, double decay, int restarts, out int info, out mlpreport rep)
-    {
-        info = 0;
-        rep = new mlpreport();
-        mlpe.mlpetraines(ensemble.innerobj, xy, npoints, decay, restarts, ref info, rep.innerobj);
+        p = new double[0,0];
+        rep = new mcpdreport();
+        mcpd.mcpdresults(s.innerobj, ref p, rep.innerobj);
         return;
     }
